Summary: mod_dosevasive is an evasive maneuvers module for Apache.
Name: mod_dosevasive
Version: 1.8
Release: 1
Group: System Environment/Daemons
Source0: http://www.nuclearelephant.com/projects/dosevasive/mod_dosevasive.%{version}.tar.gz
License: GPL
URL: http://www.nuclearelephant.com/projects/dosevasive/
BuildRoot: %{_tmppath}/%{name}.%{version}
Requires: webserver
BuildPrereq: /usr/sbin/apxs

%description
mod_dosevasive is an evasive maneuvers module for Apache to provide evasive action in the event of an HTTP DoS or DDoS attack or brute force attack. It is also designed to be a detection and network management tool, and can be easily configured to talk to ipchains, firewalls, routers, and etcetera. mod_dosevasive presently reports abuses via email and syslog facilities.

%prep
%setup -q

# Several if/elif statements to use one RPM for both Apache versions

%build
if [ -d /usr/lib/apache ]; then
  /usr/sbin/apxs -c mod_dosevasive.c
elif [ -d /usr/lib/httpd/modules ]; then
  /usr/sbin/apxs -c mod_dosevasive20.c
fi

%install
rm -rf RPM_BUILD_ROOT

if [ -d /usr/lib/apache ]; then
  mkdir -p $RPM_BUILD_ROOT/usr/lib/apache
  mkdir -p $RPM_BUILD_ROOT/etc/httpd/conf
  install -c -m 755 .libs/mod_dosevasive.so $RPM_BUILD_ROOT/usr/lib/apache
  install -c -m 644 mod_dosevasive.conf $RPM_BUILD_ROOT/etc/httpd/conf
elif [ -d /usr/lib/httpd/modules ]; then
  mkdir -p $RPM_BUILD_ROOT/usr/lib/httpd/modules
  mkdir -p $RPM_BUILD_ROOT/etc/httpd/conf
  install -c -m 755 .libs/mod_dosevasive20.so $RPM_BUILD_ROOT/usr/lib/httpd/modules
  install -c -m 644 mod_dosevasive20.conf $RPM_BUILD_ROOT/etc/httpd/conf
fi

mkdir -p $RPM_BUILD_ROOT/usr/share/doc/mod_dosevasive
install -c -m 644 LICENSE $RPM_BUILD_ROOT/usr/share/doc/mod_dosevasive
install -c -m 644 README $RPM_BUILD_ROOT/usr/share/doc/mod_dosevasive

%clean
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
/usr/lib/*
/etc/httpd/conf/*
/usr/share/doc/mod_dosevasive/LICENSE
/usr/share/doc/mod_dosevasive/README

%post
if [ -d /usr/lib/apache ]; then
  if grep -l "Include conf/mod_dosevasive.conf" /etc/httpd/conf/httpd.conf > /dev/null 2>&1; then
    PATH="$PATH:/sbin" ldconfig -n /usr/lib/apache
  else
    PATH="$PATH:/sbin" ldconfig -n /usr/lib/apache
    echo "Include conf/mod_dosevasive.conf" >> /etc/httpd/conf/httpd.conf
  fi
elif [ -d /usr/lib/httpd/modules ]; then
  if grep -l "Include conf/mod_dosevasive20.conf" /etc/httpd/conf/httpd.conf > /dev/null 2>&1; then
    PATH="$PATH:/sbin" ldconfig -n /usr/lib/httpd/modules
  else
    PATH="$PATH:/sbin" ldconfig -n /usr/lib/httpd/modules
    echo "Include conf/mod_dosevasive20.conf" >> /etc/httpd/conf/httpd.conf
  fi
fi

/etc/rc.d/init.d/httpd restart

%changelog
* Tue Sep 02 2003 Larry Long <larry@djslyde.com>
- Upgrading to 1.8 for new whitelist feature

* Sat Aug 30 2003 Larry Long <larry@djslyde.com>
- Added mod_dosevasive.conf/mod_dosevasive20.conf
- Added module path for ldconfig
- Added Include directive for httpd.conf
- Added Apache restart at completion of installation

* Fri Aug 29 2003 Larry Long <larry@djslyde.com>
- Initial RPM Build intended for standard Apache installations [1.3/2.0]
- Modified src dir from 'dosevasive' to 'mod_dosevasive-1.7.1' for spec file
